import os

import axipy
from axipy import Plugin, Position

from FastPanael.ui.dlgEditFastPanel import DlgEditFastPanel
from FastPanael.ui.tool.dummyObserver import factoryObserver
from FastPanael.ui.tool.helper_config import ConfigFiles


class ConfigFastPanel(Plugin):
    __name="Настройка панели быстрого доступа"
    __name_observer="DummyObserver"
    def __init__(self):
        print("Init plugin")
        self.__dlg=None
        self.__isActivateFastPanel=False
        self.__observer=factoryObserver(self.__name_observer)
        local_file_icon = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'ui/icons', 'config_32_32.png')
        self.__action = self.create_action(self.__name, icon=local_file_icon,
                                           on_click=self.__run_tools,enable_on = self.__name_observer)
        position = Position('Дополнительно', 'Инструменты')

        position.add(self.__action, size=2)
        #ConfigFiles.loadAndInitFastPanel(self.get_plugin_data_dir())
    def load(self) -> None:
        print("Run load")
        #self.__widget_main=axipy.mainwindow.qt_object()
        #self.__widget_main.windowIconChanged.connect(self.__is_active_main_windows)
        isOk=ConfigFiles.loadAndInitFastPanel(self.get_plugin_data_dir())
        if not isOk:

            print("Not load fast panel")
        else:
            self.__isActivateFastPanel=True
    def __run_tools(self):
        #print("Click")
        if not self.__isActivateFastPanel:
            ConfigFiles.loadAndInitFastPanel(self.get_plugin_data_dir())
            self.__isActivateFastPanel=True


        path_plugin__data=self.get_plugin_data_dir()
        self.__dlg=DlgEditFastPanel(path_plugin__data,axipy.mainwindow.qt_object())
        self.__dlg.exec_()
        self.__dlg=None
    def __is_active_main_windows(self,objIcon):
        print("Init main windows")
    def unload(self) -> None:
        ConfigFiles.loadAndInitFastPanel(None)


