import os

import axipy
from PySide2.QtCore import QFile, QItemSelectionModel, QSize
from PySide2.QtGui import QStandardItemModel, QStandardItem
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog, QPushButton

from FastPanael.ui.dlg_config_fast_panel import WidgetConfig
from FastPanael.ui.tool.db.dbTools import DbTools
def findGroup(groups,name_group):
    for group in groups:
        if group['name']==name_group:
            return group['id']
    return None
class ResourceDbAction:
    __name_table_function='class_function'
    __name_table_action = 'list_operation'
    def __init__(self,db):
        self.__db=db
    def getGroups(self):
        sql_select="Select * from "+self.__name_table_function+" order by id_view"
        result=self.__db.select(sql_select)
        groups_name=[]
        for row in result:
            if row[1]=='Неотображаемые':
                continue
            groups_name.append({'id':row[0],"name":row[1]})
        return groups_name
    def getActions(self,id):
        sql="Select * from "+self.__name_table_action+" where fk_function="+str(id)+" order by id_view"
        result=self.__db.select(sql)
        list_action=[]
        for row in result:
            list_action.append({'name_action':row[2],'name':row[3]})
        return list_action
class DlgEditFastPanel(QDialog):
    def __init__(self,path_folder,parent=None):
        super().__init__(parent)
        self.__ui=self.load_ui("main_dlg_1.ui",parent)
        self.__initDb()
        self.__initListGroup()
        self.__widget_conf_fast=WidgetConfig(path_folder,self.__ui.frame_config)
        self.__ui.verticalLayoufast_panel.addWidget(self.__widget_conf_fast)
        jkl=self.__ui.verticalLayoufast_panel.count()
        jkl=0
    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
    def __initDb(self):
        path = os.path.join(os.path.dirname(__file__), "dictionary_fast_panel.db")
        self.__db=DbTools(path)
        self.__db_descriptions=ResourceDbAction(self.__db)

    def __initListGroup(self):
        self.__groups=self.__db_descriptions.getGroups()
        self.__model_grops = QStandardItemModel()
        self.__ui.list_group.setModel(self.__model_grops)
        self.__ui.list_group.selectionModel().selectionChanged.connect(self.__change_selection_group)
        for i,group in enumerate(self.__groups):
            item = QStandardItem(group['name'])

            self.__model_grops.appendRow(item)

        ix = self.__model_grops.index(0, 0)
        sm = self.__ui.list_group.selectionModel()
        sm.select(ix,QItemSelectionModel.Select)
        #self.__ui.list_group.setCurrentItem(0)
    def __change_selection_group(self,values):
        item =self.__ui.list_group.selectionModel().selection().indexes()[0]
        name_group=item.data()
        self.__initActionsView(name_group)
        jkl=0
    def __initActionsView(self,name_group):
        self.__clearLayoutActions()
        id_group=findGroup(self.__groups,name_group)
        actions_des=self.__db_descriptions.getActions(id_group)
        colum_count=5
        i=0
        for action_des in actions_des:
            action=axipy.action_manager.get(action_des['name_action'])
            if action is None:
                continue
            icon=action.icon()
            if icon is None:
                bt_action =    QPushButton(icon, action_des['name'])
            else:
                bt_action=QPushButton(icon,'')
            bt_action.name_action=action_des['name_action']
            #bt_action.clicked.connect(self.__click_action)
            #bt_action.clicked.connect(lambda :self.__click_action(action_des['name_action']))
            bt_action.clicked.connect(self.__click_action)
            bt_action.setFixedSize(QSize(40, 40))
            bt_action.setToolTip(action_des['name'])
            col=i % colum_count
            row=int(i/colum_count)
            self.__ui.grid_image.addWidget(bt_action,row,col)
            i=i+1
    def __clearLayoutActions(self):
        while self.__ui.grid_image.count():
            child = self.__ui.grid_image.takeAt(0)
            if child.widget():
                child.widget().clicked.disconnect()
                child.widget().deleteLater()

    def __click_action(self):

        sender=self.sender()
        if isinstance(sender,QPushButton):
            name_action=sender.name_action
            self.__widget_conf_fast.addAxiAction(name_action)
    def exec_(self):
        self.__ui.exec_()

