import json
import time
from pathlib import Path

import axipy
from PySide2 import QtWidgets as qw
def getMenubar():

    try:

        qt_widget = axipy.mainwindow.qt_object()

        menu_bar = next(m for m in qt_widget.findChildren(qw.QMenuBar) if m.objectName() == "axiomaTitanRibbonBar")
        return menu_bar
    except:
        return None
class ConfigFiles:
    @staticmethod
    def getActiveConfig(path_folder:Path,name_active='curent.cnfg'):
        path_file=path_folder.joinpath(name_active)
        if not path_file.exists():
            return None
        with open(str(path_file), encoding='utf-8') as file:
            for line in file:
                line_cut = line.strip()
                if len(line_cut)>0:
                    if line_cut=='None':
                        return None
                    return ConfigFiles.readConfig(path_folder,line_cut)
    @staticmethod
    def setActiveConfig(path_folder:Path,name_file,name_active='curent.cnfg'):
        out_file_name=name_file

        if name_file is None:
            out_file_name="None"
        path_file = path_folder.joinpath(name_active)
        with open(str(path_file), 'w', encoding='utf-8') as f:
            f.write(out_file_name)

    @staticmethod
    def readConfig(path_folder,name_config):
        path_file=path_folder.joinpath(name_config)
        if not path_file.exists():
            return None
        des_fast=None
        with open(str(path_file)) as f:
            des_fast=json.load(f)
        return des_fast
    @staticmethod
    def save_config(path_file,curent_actions):
        out_dict={}
        out_dict['name_actions']=curent_actions
        try:
            with open(str(path_file), 'w', encoding='utf-8') as f:
                # Serialize the data and write it to the file
                json.dump(out_dict, f, ensure_ascii=False)
            return True
        except:
            return False

    @staticmethod
    def loadAndInitFastPanel(path_folder,name_active='curent.cnfg'):
        if path_folder is not None:
            curent_actions_obj=ConfigFiles.getActiveConfig(path_folder)
            if curent_actions_obj is None:
                return
        else:
            curent_actions_obj={}
            curent_actions_obj['name_actions']=['OpenFile','SaveTables','Undo','Redo']
        #print("Start load config fast panel")
        menu_bar=None

        menu_bar=getMenubar()
        if menu_bar is None:
            return False
        #print("menu_bar get")
        tool_bar = next(
            t for t in menu_bar.findChildren(qw.QToolBar) if t.objectName() == "qtn_Ribbon_Quick_Access_Bar")
        tool_bar.clear()
        count_def=4
        curent_actions=curent_actions_obj['name_actions']
        for i, name_action in enumerate(curent_actions):
            #print(name_action)
            if i == count_def:
                tool_bar.addSeparator()
            tool_bar.addAction(axipy.action_manager[name_action])
        #print("End load config fast panel")
        return True

